"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.visitTSSourceFiles = void 0;
const ts = require("typescript");
function visitTSSourceFiles(tree, visitor) {
    let result = undefined;
    for (const sourceFile of visit(tree.root)) {
        result = visitor(sourceFile, tree, result);
    }
    return result;
}
exports.visitTSSourceFiles = visitTSSourceFiles;
function* visit(directory) {
    for (const path of directory.subfiles) {
        if (path.endsWith('.ts') && !path.endsWith('.d.ts')) {
            const entry = directory.file(path);
            if (entry) {
                const content = entry.content;
                const source = ts.createSourceFile(entry.path, content.toString().replace(/^\uFEFF/, ''), ts.ScriptTarget.Latest, true);
                yield source;
            }
        }
    }
    for (const path of directory.subdirs) {
        if (path === 'node_modules') {
            continue;
        }
        yield* visit(directory.dir(path));
    }
}
